import { readFileSync, writeFileSync } from "fs"

export function updateVersion(pack: string) {
  // Lee el contenido de package.json
  const packageJson = JSON.parse(readFileSync(pack, "utf8"))

  // Extrae la versión actual
  const currentVersion = packageJson.version

  // Construye la nueva versión
  const newVersion = increaseVersion(currentVersion)

  // Actualiza la versión en package.json
  packageJson.version = newVersion

  // Escribe el archivo package.json actualizado
  writeFileSync("package.json", JSON.stringify(packageJson, null, 2))

  console.log(`Version updated to ${newVersion}`)
}

function increaseVersion(version: string) {
  // Dividir la versión en partes usando el punto como separador
  let partes = version.split(".")

  // Obtener el último elemento
  let ultimoElemento = partes.pop()

  if (!ultimoElemento) throw "problem with string version"
  // Si el último elemento contiene un guion (indicativo de un sufijo), dividirlo
  let sufijo = ""
  if (ultimoElemento.includes("-")) {
    let sufijoPartes = ultimoElemento.split("-")
    ultimoElemento = sufijoPartes[0]
    sufijo = "-" + sufijoPartes.slice(1).join("-")
  }

  // Obtener el último número y convertirlo a entero
  let ultimoNumero = parseInt(ultimoElemento)

  // Incrementar el último número
  ultimoNumero++

  // Actualizar el último número en las partes
  partes.push(ultimoNumero.toString() + sufijo)

  // Unir las partes de la versión de nuevo en una cadena
  let nuevaVersion = partes.join(".")

  return nuevaVersion
}
