import { readdirSync, statSync, mkdirSync, existsSync, copyFile } from "fs"
import path from "path"

export function parsePath(path: string): string {
  return path.replace(new RegExp("//", "g"), "/")
}

export function findFolder(directory: string, nameFolder: string): string | null {
  let pathFound: string | null = null

  function searchInDirectory(directorio: string) {
    const elements = readdirSync(directorio)

    for (const element of elements) {
      const fullPath = path.join(directorio, element)
      const stats = statSync(fullPath)

      if (stats.isDirectory()) {
        if (element === nameFolder) {
          pathFound = fullPath
          break
        } else {
          searchInDirectory(fullPath)
        }
      }
    }
  }

  searchInDirectory(directory)

  return pathFound
}

export function createFolderIfNotExists(rutaCarpeta: string): void {
  if (!existsSync(rutaCarpeta)) mkdirSync(rutaCarpeta, { recursive: true })
}

export function copyFolder(origin: string, destiny: string) {
  // Ruta de la carpeta de origen
  const sourceFolder = origin
  // Ruta de la carpeta de destino
  const destinationFolder = destiny

  // Copiar la carpeta completa
  copyFile(sourceFolder, destinationFolder, (err: any) => {
    if (err) {
      console.error("Error al copiar la carpeta:", err)
    } else {
      console.log("Carpeta copiada correctamente.")
    }
  })
}
