export const formatToCLP = (valor: string): { result: string; number: number } => {
  // Convertir el valor a número
  const onlyNumbers = valor.toString().replace(/[^0-9]/g, "")
  const number = Number(onlyNumbers)
  // Verificar si es un número válido
  if (isNaN(number)) {
    return { result: "$0", number: 0 }
  }

  // set CLP format
  const formatCLP = new Intl.NumberFormat("es-CL", {
    style: "currency",
    currency: "CLP",
    minimumFractionDigits: 0,
    maximumFractionDigits: 0,
  })

  return { number, result: formatCLP.format(number) }
}

export function formatCapitalizeFirstLetter(texto: string): string {
  return texto.charAt(0).toUpperCase() + texto.substring(1)
}

export function withoutCharacterSpecial(chain: string) {
  // Expresión regular para eliminar caracteres no deseados
  const caracteresNoDeseados = /[^a-zA-Z0-9-_]/g // Permitirá letras, números, guiones y guiones bajos

  // Reemplaza los caracteres no deseados por un guion bajo
  const cadenaLimpia = chain.replace(caracteresNoDeseados, "_")

  return cadenaLimpia
}
