// Método para descargar la imagen
export const downloadImage = async (url: string) => {
  if (!isImage(url)) throw "No es Imagen"

  // Obtener datos de la URL
  const response = await fetch(url)

  const blob = await response.blob()

  // Crear un enlace temporal
  var enlace = document.createElement("a")
  // Crear una URL para el Blob
  var urlBlob = window.URL.createObjectURL(blob)
  // Establecer el atributo href del enlace con la URL del Blob
  enlace.href = urlBlob
  // Extraer el nombre del archivo de la URL
  var nombreArchivo = url.substring(url.lastIndexOf("/") + 1)
  // Establecer el atributo download con el nombre del archivo
  enlace.download = nombreArchivo
  // Simular un clic en el enlace para iniciar la descarga
  enlace.click()
  // Liberar la URL del Blob
  window.URL.revokeObjectURL(urlBlob)
}

function isImage(url: string) {
  // Expresión regular para verificar si la URL termina con una extensión de imagen común
  const extensionesImagen = /\.(jpg|jpeg|png|gif|bmp|svg)$/i

  // Comprobar si la URL coincide con la expresión regular
  return extensionesImagen.test(url)
}
