export function simulatePromise(result: any) {
  return new Promise((resolve) => {
    setTimeout(() => {
      resolve(result)
    }, 1000) // Tiempo de demora de 3 segundos
  })
}

export function simulatePromiseRandom(result: any) {
  return new Promise((resolve, reject) => {
    // Generar un número aleatorio entre 0 y 1
    const randomNumber = Math.random()

    // Simular el resultado aleatorio
    if (randomNumber < 0.5) {
      // Resolver la promesa con un valor aleatorio
      resolve(result)
    } else {
      // Rechazar la promesa con un error
      reject(new Error("¡Error! Número aleatorio demasiado alto: " + randomNumber))
    }
  })
}

export function simulatePromiseRandomWith3seconds(result: any) {
  return new Promise((resolve, reject) => {
    // Simular un retraso de 3 segundos antes de resolver o rechazar la promesa
    setTimeout(() => {
      // Generar un número aleatorio entre 0 y 1
      const randomNumber = Math.random()

      // Simular el resultado aleatorio
      if (randomNumber < 0.5) {
        // Resolver la promesa con un valor aleatorio
        resolve(result)
      } else {
        // Rechazar la promesa con un error
        reject(new Error("¡Error! Número aleatorio demasiado alto: " + randomNumber))
      }
    }, 1000) // Tiempo de demora de 3 segundos
  })
}
