export const validateRut = (rut: string) => {
  // Despejar Guión

  var regex = /^[0-9]+[-|‐]{1}[0-9kK]{1}$/.test(rut)

  if (!regex) return false

  var valor = rut.replace("-", "")

  // Aislar Cuerpo y Dígito Verificador
  var cuerpo = valor.slice(0, -1)
  var dv: string = valor.slice(-1).toUpperCase()

  // Formatear RUN
  rut = cuerpo + "-" + dv

  // Si no cumple con el mínimo ej. (n.nnn.nnn)
  if (cuerpo.length < 7) {
    return false
  }

  // Calcular Dígito Verificador
  var suma = 0
  var multiplo = 2

  // Para cada dígito del Cuerpo
  for (var i = 1; i <= cuerpo.length; i++) {
    // Obtener su Producto con el Múltiplo Correspondiente
    const index = multiplo * parseInt(valor.charAt(cuerpo.length - i))

    // Sumar al Contador General
    suma = suma + index

    // Consolidar Múltiplo dentro del rango [2,7]
    if (multiplo < 7) {
      multiplo = multiplo + 1
    } else {
      multiplo = 2
    }
  }

  // Calcular Dígito Verificador en base al Módulo 11
  var dvEsperado: number = 11 - (suma % 11)

  var dv_final: number = parseInt(dv)
  // Casos Especiales (0 y K)

  dv_final = dv === "K" ? 10 : dv_final
  dv_final = dv === "0" ? 11 : dv_final

  // Validar que el Cuerpo coincide con su Dígito Verificador
  if (dvEsperado !== dv_final) {
    return false
  }
  // Si todo sale bien, eliminar errores (decretar que es válido)
  return true
}

export function isURL(cadena: string) {
  // Expresión regular para verificar si es una URL
  const patronURL = /^https?:\/\/(?:www\.)?[^\s/$.?#].[^\s]*$/

  // Expresión regular para verificar si es una cadena de texto local

  if (patronURL.test(cadena)) return true
  return false
}
